#include "pca8575.h"

__s32 pca8575_read (int dev) {
  __s32 result;

  if ((result = i2c_smbus_read_word_data(dev, 0x00)) < 0)
    return -1;

  /* Because this protocol works with an inverted boolean
   * value, we adjust.
   */
  return (result ^ 0xFFFF) & 0xFFFF;
}

__s32 pca8575_write (int dev, __u16 data) {
  __u8 tmp;

  /* Because this protocol works with an inverted boolean
   * value, we adjust.
   */
  data ^= 0xFFFF;
  data &= 0xFFFF;

  /* I suspect this function writes the wrong way around,
   * so we swap bytes.
   */
  tmp = (__u8) (data & 0xFF);
  data = data >> 8;
  data |= (__u32) (tmp << 8);

  if (i2c_smbus_write_word_data(dev, 0x00, data) < 0)
    return -1;

  return 0;
}
